.\"	$NetBSD: compat_ultrix.8,v 1.18 2003/03/30 21:21:41 wiz Exp $
.\"
.\" Copyright (c) 1997 Jonathan Stone
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by Jonathan Stone.
.\" 4. Neither the name of the author nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd January 16, 1999
.Dt COMPAT_ULTRIX 8
.Os
.Sh NAME
.Nm compat_ultrix
.Nd "setup procedure for ULTRIX compatibility on MIPS and VAX architectures"
.Sh DESCRIPTION
.Nx Ns Tn /mips
and
.Nx Ns Tn /vax
architectures can run Risc ULTRIX and VAX
ULTRIX executables, respectively.  However, you have to worry about
the legal issues of ensuring that you have a right to use any ULTRIX
binaries on your machine.
.Pp
Most executables will work.  The exceptions include programs that use
proprietary, ULTRIX-specific features (LAT, CI support, DECnet
support) and various system calls,
.Fn ioctl Ns 's ,
or ULTRIX kernel
semantics that are difficult to emulate (e.g. ULTRIX packetfilter) or
buggy (e.g. ULTRIX
.Tn NIS ) .
.Pp
All ULTRIX executables are static, so no shared libraries are required
for ULTRIX compatibility. However, ULTRIX is based on a
.Bx 4.3
alpha release.  ULTRIX commands and libraries are often much older
than their
.Nx
or even
.Tn SunOS 4.x
equivalents, and may require
incompatible configuration files.
.Sh SYSTEM CONFIGURATION FILES
Set up
.Pa resolv.conf
and
.Pa svc.conf
as below:
.Pp
.Bl -tag -width 123 -compact -offset indent
.It # mkdir -p /emul/ultrix/etc
.br
.It # cd /emul/ultrix/etc
.br
.It # egrep 'domain|nameserver' /etc/resolv.conf  \*[Gt] ./resolv.conf
.br
.It # cp -p /usr/share/examples/emul/ultrix/etc/*	./
.El
.Ss /etc/resolv.conf
The ULTRIX resolver library only understands
.Sy domain
and
.Sy nameserver
lines in
.Xr resolv.conf 5 .
You should create a copy of
.Pa /etc/resolv.conf
containing only those commands and put it in
.Pa /emul/ultrix/etc/resolv.conf .
Note that the
domain search order used by ULTRIX executables may not be the same as
native binaries; there is no good way around this.
.Ss /etc/svc.conf
ULTRIX uses
.Pa /etc/svc.conf
to select an ordered search of
.Tn NIS ,
Hesiod,
or local flat-file mappings.  You should create an
.Pa /emul/ultrix/etc/svc.conf
specifying either local files or bind (DNS)
lookups for all ULTRIX name services.
.Sh SEE ALSO
.Xr resolv.conf 5
.Sh BUGS
RISC ULTRIX
.Tn NIS
(YP) is known to not work.  The ULTRIX
.Tn NIS
libraries have a consistent endian-ness bug. ULTRIX
.Tn NIS
client will not inter-operate with the
.Nx
.Xr ypbind 8
process.  The only workaround is to use
.Pa /etc/svc.conf
to disable
.Tn NIS
(YP).
.Pp
The ndbm hashed-password file used by ULTRIX are incompatible with the
db hashed-password file used by
.Nx .
There is no good solution for
this.
.Tn NIS
would be a good one, if ULTRIX
.Tn NIS
worked.
.Pp
The API used by Xservers to talk to the kernel is currently compatible
with ULTRIX 4.1.  An implementation of the ULTRIX 4.2 Xws interface
(used by X11R6) is in progress.
.Pp
A complete list of things which fail to work in ULTRIX compatibility
mode should be added here.
